;lecture_diffusion_task1d
;von Neumann B.C.
;

fxhelp=fx0
;Compute Fourier components for von Neumann B.C.
maxk=nx-1; how may coeficients?
ak_vec=fltarr(maxk+1) ; fourier coefficients
;now use cos transform
for k=1,maxk do begin
help1=total(fxhelp*cos(k*!pi*x/Lx))
ak_vec[k]=(2.0*dx/Lx)*help1
endfor
rho=fltarr(nx)
for k=1,n_elements(ak_vec)-1 do begin
ak=ak_vec[k]
dummy=ak*cos(k*!pi*x/Lx)
rho=rho+dummy
endfor
a0=-rho[0] & ak_vec[0]=a0

;
;Compute and display time dependent solution
erase
;nt=10 ; if nt=1 then we just show rho(x,0)
for it=0,nt-1 do begin; do begin; time evolution
t=tvec[it]
rho=fltarr(nx);0.0*x;a0+heat*x;linpart

;Compute solution for time t
for k=0,n_elements(ak_vec)-1 do begin
ak=ak_vec[k]
dummy=ak*cos(k*!pi*x/Lx)
dummy2=exp(-(k^2*!pi^2*D*t)/Lx^2)
rho=rho+dummy*dummy2
endfor
plot,x,rho,yrange=1.0*[-0.2,1.2*A],linestyle=0,thick=2,$
xtitle='x',ytitle='rho',title='1D Diffusion equation',$
charsize=1.5
oplot,x,fx0,linestyle=1
xyouts,2,-0.3,'t='+string(strcompress(t)),size=2
;print,'Int rho dx=',total(rho)*dx
wait,0.2
endfor